package com.baicizhan.client.business.view

import android.animation.Animator
import android.content.Context
import android.util.AttributeSet
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.constraintlayout.widget.Group
import com.baicizhan.client.framework.log.L
import kotlinx.android.synthetic.main.layout_bcz_web_error.view.*

/**
 * Created by Jacee.
 * Date: 2020.10.29
 */
class WebBlankView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyle: Int = 0, defStyleRes: Int = 0) :
    ConstraintLayout(context, attrs, defStyle, defStyleRes) {

    private lateinit var widgetsGroup: Group

    override fun onFinishInflate() {
        super.onFinishInflate()
        widgetsGroup = group
    }

    @JvmOverloads
    fun setVisible(visible: Boolean, animated: Boolean = false) {
        animate().cancel()
        widgetsGroup.visible = visible
        L.d(TAG, "set visible: $visible, animated: $animated")
        val targetAlpha = if (visible) 1f else 0f;
        if (animated) {
            animate().alpha(targetAlpha)
                .setDuration(350)
                .setStartDelay(1000)
                .setListener(object : Animator.AnimatorListener {
                    override fun onAnimationStart(animation: Animator?) {
                        if (visible)
                            this@WebBlankView.visible = true
                    }

                    override fun onAnimationEnd(animation: Animator?) {
                        if (!visible)
                            this@WebBlankView.visible = false
                    }

                    override fun onAnimationCancel(animation: Animator?) {
                    }

                    override fun onAnimationRepeat(animation: Animator?) {
                    }

                })
                .start()
        } else {
            this@WebBlankView.alpha = targetAlpha
            this@WebBlankView.visible = visible
        }
    }

    companion object {
        private val TAG = WebBlankView::class.java.simpleName
    }

}